---
title: WEBGL_debug_renderer_info
slug: Web/API/WEBGL_debug_renderer_info
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_debug_renderer_info</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes two constants with information about the graphics driver for debugging purposes.</p>

<p>Depending on the privacy settings of the browser, this extension might only be available to privileged contexts. Generally, the graphics driver information should only be used in edge cases to optimize your WebGL content or to debug GPU problems. The {{domxref("WebGLRenderingContext.getParameter()")}} method can help you to detect which features are supported and the <code><a href="/en-US/docs/Web/API/HTMLCanvasElement/getContext">failIfMajorPerformanceCaveat</a></code> context attribute lets you control if a context should be returned at all, if the performance would be dramatically slow.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> Depending on the privacy settings of the browser, this extension might only be available to privileged contexts or not work at all. In Firefox, if <code>privacy.resistFingerprinting</code> is set to <code>true</code>, this extensions is disabled.</p>

<p>This extension is available to both, {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} and {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}} contexts.</p>
</div>

<h2 id="Constants">Constants</h2>

<dl>
 <dt>ext.UNMASKED_VENDOR_WEBGL</dt>
 <dd>Vendor string of the graphics driver.</dd>
 <dt>ext.UNMASKED_RENDERER_WEBGL</dt>
 <dd>Renderer string of the graphics driver.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>With the help of this extension, privileged contexts are able to retrieve debugging information about the user's graphic driver:</p>

<pre class="brush: js">var canvas = document.getElementById('canvas');
var gl = canvas.getContext('webgl');

var debugInfo = gl.getExtension('WEBGL_debug_renderer_info');
var vendor = gl.getParameter(debugInfo.UNMASKED_VENDOR_WEBGL);
var renderer = gl.getParameter(debugInfo.UNMASKED_RENDERER_WEBGL);

console.log(vendor);
console.log(renderer);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_debug_renderer_info', "", "WEBGL_debug_renderer_info")}}</td>
   <td>{{Spec2('WEBGL_debug_renderer_info')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_debug_renderer_info")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
</ul>
